---
title: API reference sidebars
slug: MDN/Structures/API_references/API_reference_sidebars
tags:
  - API
  - Documentation
  - Guide
  - MDN
  - MDN Meta
  - Reference
  - groupdata
  - metadata
  - onboarding
  - sidebars
---
<div>{{MDNSidebar}}</div>

<p class="summary">You are able to include a custom sidebar on API reference pages it so that it displays links to related Interfaces, tutorials, and other resources relevant just to that API. This article explains how.</p>

<h2 id="Creating_a_sidebar">Creating a sidebar</h2>

<p>You need to take the following three steps to create your API sidebar:</p>

<ol>
	<li>Create your API reference pages.</li>
	<li>Add an entry for your particular API into the <a href="https://github.com/mdn/kumascript">KumaScript repo</a>'s <code>GroupData.json</code> data file.</li>
	<li>Use the {{TemplateLink("APIRef")}} macro to insert the sidebar into each page you want to display it on.</li>
</ol>

<p>Let's run through each of these steps in turn. The example we'll refer to in this article is the <a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a>.</p>

<h3 id="Creating_your_API_reference_pages">Creating your API reference pages</h3>

<p>Before you can add sidebars to your pages, you'll need to create the pages themselves (see our <a href="/en-US/docs/MDN/Contribute/Structures/API_references/What_does_an_API_reference_need">What does an API reference need?</a> guide for more guidance).</p>

<h3 id="Adding_an_entry_to_GroupData.json">Adding an entry to GroupData.json</h3>

<p>The <code><a href="https://github.com/mdn/kumascript/blob/master/macros/GroupData.json">GroupData.json</a></code> file holds all the data relating to what links should appear in API reference sidebars. When invoked, the {{TemplateLink("APIRef")}} macro takes an API name given to it as a parameter, looks up that name in <code>GroupData.json</code>, builds an appropriate sidebar, and inserts it into the page.</p>

<p>To add an entry to <code>GroupData.json</code>, you need to:</p>

<ol>
	<li>Make sure you have a <a href="https://github.com/">GitHub</a> account.</li>
	<li>Fork the KumaScript repo, create a new branch to contain your changes, and clone the repo locally.</li>
	<li>Checkout your new branch before starting work, and make sure you push changes to it after finishing.</li>
	<li>Create a pull request so that the MDN team can review your work, and ask for changes if necessary.</li>
</ol>

<p>If you need help with using GitHub, a more detailed guide can be found at our <a href="/en-US/docs/MDN/Contribute/Structures/Compatibility_tables#The_new_way_The_browser_compat_data_repo_and_dynamic_tables">compatibility tables guide</a>.</p>

<p>The <code><a href="https://github.com/mdn/kumascript/blob/master/macros/GroupData.json">GroupData.json</a></code> file can be found inside the macros directory of the KumaScript repo. Looking at it, you'll see a giant JSON structure, with each API having its own member. The name is the API name, and the value is an object containing several sub-members defining the sidebar links to be created.</p>

<p>For example, look at the <a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a> page on MDN. The corresponding entry in <code>GroupData.json</code> looks like this:</p>

<pre class="brush: json notranslate">"Fetch API": {
    "overview":   [ "Fetch API"],
    "interfaces": [ "Body",
                    "Headers",
                    "Request",
                    "Response",
                    "FetchController",
                    "FetchObserver",
                    "FetchSignal",
                    "ObserverCallback" ],
    "methods":    [ "WindowOrWorkerGlobalScope.fetch()" ],
    "properties": [],
    "events":     []
},</pre>

<p>As you can see, we've used "Fetch API" for the name, and inside the object value we include a number of sub-members.</p>

<h4 id="Sub-members_to_include_inside_a_GroupData_entry">Sub-members to include inside a GroupData entry</h4>

<p>This section lists all the sub-members you could include in a <code>GroupData</code> entry.</p>

<p>Note that most of the values included inside the listed sub-members equate to both the link text, and slugs appended to the end of the main API index page —  <code>https://developer.mozilla.org/<em>&lt;language-code&gt;</em>/docs/Web/API</code> — to create the final URL for the displayed link. So for example, "Body" will result in a link being created like so in the <em>en-US</em> locale:</p>

<pre class="brush: html notranslate">&lt;li&gt;&lt;a href="/en-US/docs/Web/API"&gt;Body&lt;/a&gt;&lt;/li&gt;</pre>

<p>There are a few exceptions. For example the "guides" sub-member contains one or more sets of link information (title and slug) that defines links to associated guides/tutorials. In this case the slugs are appended to the end of the MDN docs root — https://developer.mozilla.org/<em>&lt;language-code&gt;</em>/docs — allowing an article anywhere on MDN to be included.</p>

<p>Here are the available members. In each case, an example is included that assumes that the locale is <em>en-US</em>. These are all technically optional, but it is strongly encouraged that instead of omitting them, you include empty arrays.</p>

<ol>
	<li>
	<p><code>"overview"</code> — the value is an array, inside of which you include the slug of the API overview page, if there is one. "Fetch API" results in a link being made to <a href="/en-US/docs/Web/API/Fetch_API">https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API</a>.</p>
	</li>
	<li>
	<p><code>"interfaces"</code> — the value is an array in which you should list all of the interfaces that form part of that API. "Body" results in a link being made to <a href="/en-US/docs/Web/API/Body">https://developer.mozilla.org/en-US/docs/Web/API/Body</a>.</p>
	</li>
	<li>
	<p><code>"methods"</code> — the value is an array that should contain any methods the spec adds to interfaces associated with other APIs, such as instantiation methods created on {{domxref("Navigator")}} or {{domxref("Window")}}. If there are a huge number of methods, you might want to consider only listing the most popular ones, or putting them first in the list. "WindowOrWorkerGlobalScope.fetch()" results in a link being made to <a href="/en-US/docs/Web/API/WindowOrWorkerGlobalScope/fetch">https://developer.mozilla.org/en-US/docs/Web/API/WindowOrWorkerGlobalScope/fetch</a>. Do <em>not</em> list methods that are members of interfaces that are members of interfaces that are owned by the same API.</p>
	</li>
	<li>
	<p><code>"properties"</code> — the value is an array that should contain all of the properties associated with the API. This can include properties that are members of interfaces defined in the API spec, and properties the API defines on other interfaces. If there are a huge number of properties, you might want to consider only listing the most popular ones, or putting them first in the list. "Headers.append" results in a link being made to <a href="/en-US/docs/Web/API/Headers/append">https://developer.mozilla.org/en-US/docs/Web/API/Headers/append</a>.</p>
	</li>
	<li>
	<p><code>"events"</code> — the value is an array that should contain all of the events associated with the API, defined in the API spec, or elsewhere. If there are a huge number of events, you might want to consider only listing the most popular ones, or putting them first in the list. "animationstart" results in a link being made to <a href="/en-US/docs/Web/Events/animationstart">https://developer.mozilla.org/en-US/docs/Web/Events/animationstart</a>.</p>
	</li>
	<li>
	<p><code>"guides"</code> — the value is an array containing one or more objects that define links to guides explain how to use the API. Each object contains two sub-members — "url", which contains the partial URL pointing to the guide article, and "title", which defines the link test for the link. As an example, the following object:</p>

	<pre class="brush: json notranslate">{ "url":   "/docs/Web/API/Detecting_device_orientation",
"title": "Detecting device orientation" }</pre>

	<p>Creates a link with the title "Detecting device orientation", which points to <a href="/en-US/docs/Web/API/Detecting_device_orientation">https://developer.mozilla.org/en-US/docs/Web/API/Detecting_device_orientation</a>.</p>
	</li>
	<li>
	<p><code>"dictionaries"</code> — an array of strings listing all of the dictionaries which are part of the API. Generally, only dictionaries used by more than one property or method should be listed here, unless they are of special significance or are likely to require being referenced from multiple pages. "RTCConfiguration" results in a link to <a href="/en-US/docs/Web/API/RTCConfiguration">https://developer.mozilla.org/en-US/docs/Web/API/RTCConfiguration</a>.</p>
	</li>
	<li>
	<p><code>"types"</code> — an array of typedefs and enumerated types defined by the API. You may choose to only list those that are of special importance or are referenced from multiple pages, in order to keep the list short. "RTCCodecType" creates a link to <a href="/en-US/docs/Web/API/RTCCodecType">https://developer.mozilla.org/en-US/docs/Web/API/RTCCodecType</a>.</p>
	</li>
	<li>
	<p><code>"callbacks"</code> — the value is an array containing a list of all the defined callback types for the API. You may find it unnecessary to use this group at all, even on APIs that include callback types, as often they are not useful to document separately. An entry in this array containing the string "RTCSessionDescriptionCallback" results in a link being created to <a href="/en-US/docs/Web/API/RTCSessionDescriptionCallback">https://developer.mozilla.org/en-US/docs/Web/API/RTCSessionDescriptionCallback</a>.</p>
	</li>
</ol>

<h2 id="Tags_used_by_sidebars">Tags used by sidebars</h2>

<p>Some sub-members are automatically discovered from child pages, based on page tags.  Pages under the top-level API are crawled each time the sidebar is rendered, and entries are automatically created for methods ("Method" tag), properties ("Property" tag), and constructors ("Constructor" tag).</p>

<p>Sub-members are automatically decorated with warning icons based on tags as well.  Decorations are added for experimental ("Experimental" tag), non-standard ("Non Standard" or "Non-standard" tag), deprecated ("Deprecated" tag), or obsolete ("Obsolete" tag) sub-members.</p>

<p>Further information about tag-based processing is available <a href="https://github.com/mdn/kumascript/blob/master/macros/APIRef.ejs">in the APIRef source</a>.</p>

<h2 id="Inserting_the_sidebar">Inserting the sidebar</h2>

<p>Once you've added an entry for your API into <code>GroupData.json</code>, submitted it as a pull request and had the change accepted into the main repo, you can include it in your API reference pages using the {{TemplateLink("APIRef")}} macro, which takes the name you used for your API in GroupData as a parameter. As an example, the <a href="/en-US/docs/Web/API/WebVR_API">WebVR API</a>'s sidebar is included in its pages with the following:</p>

<pre class="notranslate">\{{APIRef("WebVR API")}}</pre>
